Package: nesoni
Version: 0.0
License: GPL-2
Title: Nesoni R component
Description: The R component of the Nesoni toolsuite.
Author: Paul Harrison
Maintainer: Paul Harrison <paul.harrison@monash.edu>
Depends: limma, edgeR
Suggests: goseq, seriation, NMF

==========
  Nesoni 
==========

Nesoni is a high-throughput sequencing data analysis toolset,
which the VBC has developed to cope with the flood of Illumina, 
454, and SOLiD data now being produced. 

Our work is largely with bacterial genomes, and the design tradeoffs 
in nesoni reflect this.

Nesoni focusses on analysing the alignment of reads to a reference 
genome. Use of the SHRiMP and Bowtie2 read aligners is automated by 
nesoni. We use SHRiMP as it is able to detect small insertions and 
deletions in addition to SNPs. Output from other aligners may be 
imported in SAM format.

Nesoni can call a consensus of read alignments, taking care to
indicate ambiguity. This can then be used in various ways: to determine
the protein level changes resulting from SNPs and indels, to find 
differences between multiple strains, or to produce n-way comparison data 
suitable for phylogenetic analysis in SplitsTree4.


~ Requirements
==============

Python 2.7 or higher. Use of PyPy where possible is highly recommended 
for performance.

Python libraries
* Recommended:
  * BioPython [1]
* Optional (used by non-core nesoni tools):
  * matplotlib
  * numpy

External programs:
* Required:
  * SHRiMP or Bowtie2
  * samtools
* Required for VCF based variant calling:
  * Picard [2]
  * Freebayes
* Optional for VCF based variant calling:
  * SplitsTree4

R libraries required by R-based tools (mostly for RNA-seq):
* Required:
  * limma, edgeR from BioConductor
  * seriation
* Optional:
  * goseq from BioConductor
  * NMF


[1] BioPython is used for reading GenBank files.
    Compiled modules may need to be disabled when installing in PyPy.

[2] There does not seem to be a standard way to install .jar files. 
    Nesoni will search for .jar files in directories listed in 
    environment variables $PATH and $JARPATH.


~ Installation
==============

The easy way to install or upgrade:

    pip install -I nesoni

Then type "nesoni" and follow the command to install the R module.

See below for more ways to install nesoni.


 Advanced Installation 
-----------------------

From source, download and untar the source tarball, then:

    python setup.py install

Optional:

    R CMD INSTALL nesoni/nesoni-r


For PyPy it seems to be currently easiest to install nesoni in 
a virtualenv:

    virtualenv -p pypy my-pypy-env
    my-pypy-env/bin/pip install -I biopython 
    my-pypy-env/bin/pip install -I nesoni

You can also set up a CPython virtualenv like this:

    virtualenv my-python-env
    my-python-env/bin/pip install -I numpy 
    my-python-env/bin/pip install -I matplotlib 
    my-python-env/bin/pip install -I biopython 
    my-python-env/bin/pip install -I nesoni


 Installing older versions
---------------------------

The interface and API for nesoni may change between versions (I try to
keep this to a minimum). In order to run a script or python program
that needs an older version, I suggest setting up a virtualenv.

For example, if you want version 0.95:

    virtualenv -p pypy my-old-env
    my-old-env/bin/pip install -I biopython 
    my-old-env/bin/pip install -I nesoni==0.95

(Note: I don't have a neat way to make this work with the R components 
of nesoni.)


~ Using nesoni
==============

Type

    nesoni

for usage instructions.

nesoni can also be used without installing, from the directory in
which you unpacked it:

    python -m nesoni

# Read a table
# If it contains a line starting with #Groups, group columns as indicated
# Returns a list group.name -> data.frame

read.grouped.table <- function(filename, require=c()) {
    groups <- c()
    tab.separated <- FALSE
    
    f <- file(filename,'r')
    repeat {
        line <- readLines(f,1)
        if (length(line) == 0) break;
        if (substr(line,1,1) != '#') {
            tab.separated <- (length(grep('\t',line)) > 0)
            break;
        }
        
        parts <- strsplit(line,',')[[1]]
        if (parts[1] == '#Groups') {
            groups <- parts[basic.seq(length(parts)-1)+1]
        }
    }
    close(f)

    if (tab.separated)
        data <- read.delim(filename, comment.char='#', check.names=FALSE)    
    else    
        data <- read.csv(filename, comment.char='#', check.names=FALSE)
    
    rownames(data) <- data[,1]
    data <- data[ ,2:ncol(data), drop=FALSE]


    # === Fallbacks if groups not given ===
        
    if (!length(groups)) {
        rpkms <- grep('^RPKM', colnames(data))
        if (length(rpkms)) {
            # === Legacy count file ===
            n_samples <- rpkms[1] - 1
            groups <- c(
                rep('Count', n_samples),
                rep('RPKM', n_samples),
                rep('Annotation', ncol(data)-n_samples*2)
            )
        }
    }
    if (!length(groups)) {
        groups <- c('All')
    }

    
    i <- 2
    while(i <= ncol(data)) {
        if (is.null(groups[i]) || is.na(groups[i]) || groups[i] == '')
            groups[i] <- groups[i-1]
        i <- i + 1
    }
        
    groups <- factor(groups)
    
    result <- list()
    for(name in levels(groups)) {
        result[[name]] <- data[,groups == name,drop=FALSE]
    }
    
    for(item in require)
        if (is.null( result[[item]] ))
            stop('Table ',filename,' has no group ',item,'. Is it in the right format?')
    
    result
}


# groups should be a list of data frames
write.grouped.table <- function(groups, filename, comments=c(), rowname.title='Names') {
    # === Sanity check ===
        
    n.groups <- length(groups)
    n.groups >= 1 || stop('Need at least one group of columns to write')
    
    row.names <- rownames(groups[[1]])
    
    for(i in basic.seq(n.groups)) {
        is.data.frame(groups[[i]])                || stop('Not a data frame: ',i,' ',names(groups)[[i]])
        nrow(groups[[i]]) == nrow(groups[[1]])    || stop('Wrong number of rows: ',i,' ',names(groups)[[i]])
        all( rownames(groups[[i]]) == row.names ) || stop('Row names don\'t match: ',i,' ',names(groups)[[i]])
    }

    
    # === Construct data frame ===
    
    column.groups <- character()
    column.names <- character()
    frame <- data.frame(row.names = row.names, check.names=FALSE, check.rows=FALSE)
    
    col <- 1
    column.groups[col] <- ''
    column.names[col] <- rowname.title
    frame[,col] <- row.names
    col <- col+1

    for(i in basic.seq(n.groups)) {
        for(j in basic.seq(ncol(groups[[i]]))) {
            column.groups[col] <- names(groups)[[i]]
            column.names[col] <- colnames(groups[[i]])[j]
            frame[,col] <- groups[[i]][,j]
            col <- col+1
        }
    }
    
    colnames(frame) <- column.names

    # === Don't repeat column group names ===
    
    i <- length(column.groups)
    while(i >= 2) {
        if (column.groups[i] == column.groups[i-1])
            column.groups[i] <- ''
        i <- i - 1
    }


    # === Output ===
   
    sink(filename)
    
    for(comment in comments) {
        cat('#',comment,'\n',sep='')
    }
    
    cat('#Groups',paste(column.groups,collapse=','),'\n',sep='')
    
    write.csv(frame, row.names=FALSE)
    sink()
}

basic.seq <- function(n) {
    # Count from 1 to n inclusive without being clever
    
    if (n < 1)
        numeric(0)
    else
        1:n
}

basic.subset <- function(object, rows) {
    # Get rows by boolean vector
        
    stopifnot(is.logical(rows))
    
    # Don't tile selection
    stopifnot( length(rows) == nrow(object) )
    
    # Don't drop down to vector if single row selected
    object[rows,,drop=FALSE]
}

basic.take <- function(object, rows) {
    #Get rows by index

    stopifnot(is.numeric(rows))    
    stopifnot(all(rows >= 1))
    stopifnot(all(rows <= nrow(object)))
    
    object[rows,,drop=FALSE]
}

basic.image <- function(x,y,z, col, breaks) {
    if (length(x) > 0 && length(y) > 0) {
        image(x=x, y=y, z=z,col=col,breaks=breaks,xaxt="n",yaxt="n",xlab='',ylab='')
    }
}

# Compare outputs from "test-counts:" (can be read using read.delim)
# or any data frame with columns "Feature" and "FDR", sorted by significance

compare.tests <- function(filename.prefix, a, b, n=50, title='', a.title='', b.title='') {
    png(sprintf('%s.png', filename.prefix), width=800,height=20*n)
    plot.new()
    plot.window(c(0,30), c(0,n+4), mar=c(0,0,0,0))
    
    text(15,n+3, title,adj=0.5)
    text(10,n+1.5, a.title,adj=1)
    text(20,n+1.5, b.title,adj=0)
    text(1,n+1.5,'FDR',adj=0)
    text(25,n+1.5,'FDR',adj=0)
    
    for(i in 1:n) {
        if (a$FDR[i] < 0.01) col <- 'dark green'
        else if (a$FDR[i] < 0.05) col <- 'blue'
        else col <- 'black'
        text(10,n+1-i, a$Feature[i], adj=1, col=col)
        text(1,n+1-i, sprintf('%.2g',a$FDR[i]), adj=0, col=col)
        
        if (b$FDR[i] < 0.01) col <- 'dark green'
        else if (b$FDR[i] < 0.05) col <- 'blue'
        else col <- 'black'
        text(20,n+1-i, b$Feature[i], adj=0, col=col)
        text(25,n+1-i, sprintf('%.2g',b$FDR[i]), adj=0, col=col)
    }
    
    for(i in 1:n)
      for(j in 1:n)
        if (as.character(a$Feature[i]) == as.character(b$Feature[j])) 
          lines(c(10,11,19,20),c(n+1-i,n+1-i,n+1-j,n+1-j))
    
    dev.off()
}

# NMF on RNAseq expression data
# The weighting scheme is inspired by voom, but is more primitive: 
# it is weighted per-gene rather than per count


nmf.reordering <- function(fac.basis, fac.coef, other.basis, other.coef) {
    common.genes <- intersect(rownames(fac.basis), rownames(other.basis))
    stopifnot(length(common.genes) > 0)

    common.samples <- intersect(colnames(fac.coef), colnames(other.coef))
    stopifnot(length(common.samples) > 0)
    
    similarity <- function(i,j) {
       sum( fac.basis[common.genes,i] * other.basis[common.genes,j] ) *
       sum( fac.coef[i,common.samples] * other.coef[j,common.samples] )       
    }

    n <- ncol(fac.basis)
    n.other <- ncol(other.basis)

    num <- rep(0, n)
    den <- rep(0, n)
    for(i in 1:n) {
        for(j in 1:n.other) {
            s <- similarity(i,j)
            num[i] <- num[i] + s*j
            den[i] <- den[i] + s
        }
    }
    
    order(num / den)
}


# order hint is a list containing $fac.basis and $fac.coef
# (i.e. output of a previous invocation of nmf.counts)
# factorization will attempt to mimic order of this if given
#
nmf.dgelist <- function(dgelist, n.classes, scaling.iters=5, nmf.runs=20, order.hint=NULL) {
    library(NMF) #NMF needs to run some initialization
    
    counts <- normalized.counts(dgelist)

    row.average <- rowMeans(counts)

    # Initial guess is Poisson errors
    #scaler <- sqrt(rowSums(counts))
    scaler <- rowMeans(counts) + 0.5
    
    # Refine scaler    
    for(i in 1:scaling.iters) {
        massaged <- counts / scaler
        fac <- NMF::nmf(massaged, n.classes, method='lee', nrun=nmf.runs)
        fit <- NMF::fitted(fac) * scaler
        
        error <- sqrt(rowSums( (counts - fit)^2 ))
        loess.curve <- loess(log(error) ~ log(row.average), degree=2)
        new.scaler <- exp(loess.curve$fitted)
        
        plot(row.average, error/row.average, log='x')
        points(row.average, scaler/row.average, col='blue')
        points(row.average, new.scaler/row.average, col='red')

        scaler <- new.scaler        
    }

    # Calculate final factorization
    massaged <- counts / scaler
    fac <- NMF::nmf(massaged, n.classes, method='lee', nrun=nmf.runs)
    fac.basis <- basis(fac)
    fac.coef <- coef(fac)

    # Reorder classes
    if (!is.null(order.hint)) {
        reordering <- nmf.reordering(fac.basis, fac.coef, order.hint$fac.basis, order.hint$fac.coef)
    } else {
        reordering <- 1:n.classes
    }
    fac.basis <- fac.basis[, reordering]
    fac.coef <- fac.coef[reordering, ]

    # Remove scaling and
    # normalize factorization such that
    # gene.weight columns sum to 1
    gene.weights <- fac.basis * scaler
    temp <- colSums(gene.weights)
    sample.weights <- t( fac.coef * temp )
    gene.weights <- t(t(gene.weights) / temp)
    
    colnames(sample.weights) <- paste(1:n.classes,'of',n.classes,sep='')
    colnames(gene.weights) <- colnames(sample.weights)

    list(
        dgelist = dgelist,
        counts = counts,
        scaler = scaler,
        fac.object = fac,
        fac.reordering = reordering,
        fac.basis = fac.basis,
        fac.coef = fac.coef,
        gene.weights = gene.weights,
        sample.weights = sample.weights
    )
}


clean.nas <- function(vec, alt) { vec <- as.character(vec); ifelse(is.na(vec),alt,vec) } 

nmf.report <- function(prefix, item, glyph=NULL, annotations=c('gene','product')) {
    saveRDS(item, sprintf('%s.rds', prefix))
    
    n <- ncol(item$gene.weights)
    n.samples <- ncol(item$counts)
    n.genes <- nrow(item$counts)
      
    png(sprintf('%s-heatmap.png',prefix), width=600,height=800, pointsize=18)
    heatmap(scale(item$sample.weights[n.samples:1,],center=FALSE), Colv=NA,Rowv=NA,scale='none',col=unsigned.col,margins=c(3,12))
    dev.off()
    
    p.values <- matrix(1, nrow=n.genes, ncol=n)
    for(i in 1:n.genes) {
        non.zero <- (item$gene.weights[i,] > 1e-10)  #NMF doesn't produce exact zeros
        fit <- lm(item$counts[i,] ~ 0+I(item$sample.weights[,non.zero]))
        
        #Should be equal:
        #print(as.vector( item$gene.weights[i,non.zero] ))
        #print(as.vector( fit$coefficients ))
        
        p.values[i,non.zero] <- as.vector( summary(fit)$coefficients[,'Pr(>|t|)'] ) * 0.5
        #Single sided p values
    }
      
    
    for(j in 1:n) {
        p <- p.values[,j]
        fdr <- p.adjust(p, method='BH')
    
        result <- data.frame(
            Feature = rownames(item$counts),
            check.names = FALSE
        )
        for(annotation in annotations)
            result[,annotation] <- item$dgelist$genes[,annotation]
            
        result$FDR <- fdr  
        result$Weight <- item$gene.weights[,j]
        result <- data.frame(result, item$gene.weights, check.names=FALSE)

        result <- result[ order(result$FDR), ]
        
        significant <- result$FDR < 0.05
    
        png(sprintf("%s-%s.png",prefix,colnames(item$gene.weights)[j]), width=800, height=800, pointsize=18)
        show <- min(50,nrow(result)):1
        temp <- item$gene.weights[as.character(result$Feature[show]),]
        for(annotation in annotations)
            rownames(temp) <- paste(rownames(temp), clean.nas(result[show, annotation],''))
        rownames(temp) <- paste(ifelse(significant[show], '', '[insignificant] '), rownames(temp), sep='')
        rownames(temp) <- paste(sprintf('%.6f', result$Weight[show]), rownames(temp))
        heatmap(temp / rowSums(temp), Colv=NA,Rowv=NA,scale='none',col=unsigned.col,margins=c(6,36))
        dev.off()
    
        result <- result[significant, ]    
        #write.csv(result, file=sprintf("%s-%s.csv", prefix, colnames(item$gene.weights)[j]), na='', row.names=FALSE)    
        write.table(result, file=sprintf("%s-%s.txt", prefix, colnames(item$gene.weights)[j]), na='', sep='\t', quote=FALSE, row.names=FALSE)    
    }
    
    
    
    base.prefix <- strsplit(prefix,'/')[[1]]
    base.prefix <- base.prefix[ length(base.prefix) ]
    
    sink( sprintf('%s.html', prefix) )
    cat('<html><head><title>', base.prefix, '</title></head><body>\n')
    cat('<h1>', base.prefix, '</h1>\n')
    cat(sprintf('<p><img src="%s-heatmap.png">', base.prefix))
    
    total.sample <- sum(item$sample.weights)
    
    cat('<table cellpadding="10">\n')
    for(j in 1:n) {
        class.name <- colnames(item$gene.weights)[j]
        cat('<tr>\n')
        cat(sprintf('<td valign="top"><b>%s</b><p>%.1f%% of total<p><a href="%s-%s.txt">[table]</a></td>\n', 
            class.name, sum(item$sample.weights[,j]) * 100.0 / total.sample, base.prefix, class.name))

        if (!is.null(glyph)) {
            glyph.name <- sprintf('%s-%s-glyph.png', prefix, class.name)
            glyph(glyph.name, item$sample.weights[,j])
            cat(sprintf('<td valign="top"><img src="%s-%s-glyph.png"/></td>', base.prefix, class.name))
        }

        cat(sprintf('<td valign="top"><div style="height:150px; overflow: hidden; border:1px solid black;"><a href="%s-%s.png"><img style="border: none" src="%s-%s.png"/></a></div></td>\n',
            base.prefix, class.name, base.prefix, class.name)) 
        cat('</tr>\n')
    }
    cat('</table>')
    
    cat('</body></html>\n')
    sink()
}

aspect.ratio <- function() { par()$fin[1] / par()$fin[2] }

put.plot <- function(px1,px2,py1,py2) {
    width <- par()$fin[1]
    height <- par()$fin[2]
    
    par(
        mai=c(0,0,0,0),
        plt=c(px1,px2,py1,py2),
        new=TRUE
    )
}

color.legend <- function(col, breaks, title='') {
    if (min(breaks) != max(breaks)) {
        basic.image(x=breaks,y=c(0),z=matrix(breaks,ncol=1), col=col,breaks=breaks)
        axis(1, las=2, line=0.5)
        mtext(title, line=0.5)
    }
}


dendrogram.paths <- function(dend) {   
   if (is.leaf(dend)) {
       ''
   } else {
       result <- c()
       for(i in 1:length(dend)) {
           result <- c(result, paste(sprintf('%d',length(dend)-i), dendrogram.paths(dend[[i]])))
       }
       result
   }
}

do.dendrogram <- function(mat, enable=TRUE) {
    # Note: paths are given ordered by order

    if (nrow(mat) < 3 || !enable) {
        list(
            dendrogram = NULL,
            order = basic.seq(nrow(mat)),
            paths = rep('',nrow(mat))
        )
    } else if (nrow(mat) > 1000) {
        # Too many for seriation to deal with efficiently
        perm <- seriation::seriate(mat, method='PCA')[[1]]
        
        list(dendrogram = NULL, 
             order = seriation::get_order(perm),
             paths = rep('',nrow(mat))
        )        
    } else {
        dist.mat <- dist(mat)
        control <- list(hclust = hclust(dist.mat))
        dend.mat <- as.dendrogram(
                seriation::seriate(dist.mat, 
                method = 'OLO', 
                control = control)[[1]])
        
        list(dendrogram = dend.mat, 
             order = order.dendrogram(dend.mat),
             paths = dendrogram.paths(dend.mat)
        )
    }
}

trim.labels <- function(labels) {
    labels <- as.character(labels)
    n <- max(10, ceiling( mean(nchar(labels)) * 3.0 ))
    
    for(i in basic.seq(length(labels)))
        if (nchar(labels[i]) > n) {
            m <- n
            for(j in 1:n)
                if (any(substr(labels[i],j,j) == c(' ',',',';')))
                   m <- j
            labels[i] <- sprintf("%s...",substr(labels[i],1,m))
        }
    
    labels
}


multiplot <- function(plots, labels) {
    n.plot <- length(plots)
    
    height.inches <- par()$fin[2]

    dend.col.y1 <- 1.0 - 1.5/height.inches
    dend.col.y2 <- 1.0 - 0.1/height.inches
        
    y1 <- min(4 / height.inches, 0.4)
    y2 <- max(dend.col.y1 - 0.1/height.inches, 0.5)

    legend.y2 <- y1*0.75
    legend.y1 <- legend.y2 - 0.03*aspect.ratio()
    
    weights <- as.vector( mapply(function(i)i$weight, plots) )
    cumweights <- c(0,cumsum(weights))
    
    print(cumweights)

    annotation.x <- 0.5
    x1 <- numeric(n.plot)
    x2 <- numeric(n.plot)
    for(i in basic.seq(n.plot)) {
        margin <- 0.05 * weights[i] / cumweights[n.plot+1]
        x1[i] <- annotation.x * (cumweights[i] / cumweights[n.plot+1] + margin)
        x2[i] <- annotation.x * (cumweights[i+1] / cumweights[n.plot+1] - margin)
    }
    
    plot.new()

# = Do plots =========================================================================

    legend.x1 <- annotation.x + 0.05

    for(i in basic.seq(n.plot)) {
        plot <- plots[[i]]
        if (plot$type == 'dendrogram') {
            dendrogram <- plot$data$dendrogram
            if (!is.null(dendrogram)) {
                put.plot(x1[i],x2[i],y1,y2)
                plot(dendrogram, horiz=TRUE, axes=FALSE, yaxs="i", leaflab="none")
            }            
        
        } else if (plot$type == 'heatmap') {
            dendrogram <- plot$dendrogram$dendrogram
            if (!is.null(dendrogram)) {
                put.plot(x1[i],x2[i],dend.col.y1,dend.col.y2)
                plot(dendrogram, horiz=FALSE, axes=FALSE, yaxs="i", leaflab="none")                
            }

            if (plot$signed) {
                col <- signed.col
                extreme <- max(0.0,abs(plot$data),na.rm=TRUE)
                breaks <- seq(-extreme,extreme, length=length(col)+1)
            } else {
                col <- unsigned.col
                extreme <- max(0,plot$data,na.rm=TRUE)
                breaks <- seq(0,extreme, length=length(col)+1)
            }
            
            if (!is.null(plot$legend)) {
                legend.x2 <- legend.x1 + 0.1
                put.plot(legend.x1,legend.x2,legend.y1,legend.y2)
                color.legend(col, breaks, plot$legend)
                legend.x1 <- legend.x2 + 0.05       
            }
        
            put.plot(x1[i],x2[i],y1,y2)
            data <- plot$data
            if (nrow(data) == 1) data <- data[c(1,1),]
            if (ncol(data) == 1) data <- data[,c(1,1)]
            basic.image(basic.seq(ncol(data))-0.5, basic.seq(nrow(data))-0.5, t(data), col=col, breaks=breaks)            
            axis(1, at=basic.seq(ncol(data))-0.5, labels=colnames(data), las=2, tick=FALSE)        
            mtext(plot$title, adj=0.5, line=0.5)
                        
        } else if (plot$type == 'bar') {
            if (length(plot$data)) {
                data <- as.vector(plot$data)
                data[!is.finite(data)] <- NA
                if (!all(is.na(data))) {
                    put.plot(x1[i],x2[i],y1,y2)                
                    barplot(data, space=0, horiz=TRUE, col='black', yaxs='i',xaxt='n',lab=c(3,3,7),labels=NULL)
                    axis(1,line=0.5,las=2)
                    mtext(plot$title, adj=0.5, line=0.5)
                }
            }
        } else if (plot$type == 'scatter') {
            if (length(plot$data)) {
                data <- as.vector(plot$data)
                data[!is.finite(data)] <- NA
                if (!all(is.na(data))) {
                    put.plot(x1[i],x2[i],y1,y2)                
                    plot(data,basic.seq(length(plot$data))-0.5, ylim=c(0,length(plot$data)),yaxt='n',ylab=NA,yaxs='i',xaxt='n',xlab=NA,pch=18,bty='n',lab=c(3,3,7))
                    axis(1,line=0.5,las=2)
                    mtext(plot$title, adj=0.5, line=0.5)
                }
            }
        }
    }    

# = Do annotations ===========================================================================
#
#   Depends on there being at least one plot, as this will be an axis on the
#   last plot drawn.

    line <- 0
    for(i in basic.seq(length(labels))) {
        if (i < length(labels))
            l <- trim.labels(labels[[i]])
        else
            l <- as.character(labels[[i]])
        axis(4, at=basic.seq(length(l))-0.5, labels=l, las=2, tick=FALSE, line=line)
        line <- line + 0.5 * (1+max(0,nchar(l)))
    }
}



nesoni.heatmap <- function(mat, 
                           labels=list(), 
                           reorder.columns=FALSE, 
                           sort.mat=NULL, 
                           signed=TRUE,
                           legend='log2 Reads Per Million\ndifference from row mean',
                           levels=NULL) {    
    n.rows <- nrow(mat)
    n.cols <- ncol(mat)
    
    if (is.null(sort.mat))
       sort.mat <- t(scale(t(mat)))
    
    dend.row <- do.dendrogram( sort.mat )
    dend.col <- do.dendrogram( t(sort.mat), enable=reorder.columns )
    
    plots <- list(
            list(
                weight=1,
                type='dendrogram',
                data=dend.row
            ),
            list(
                weight=2,
                type='heatmap',
                data=mat[dend.row$order,dend.col$order,drop=FALSE],
                signed=signed,
                dendrogram=dend.col,
                legend=legend
            )
    )
    
    if (!is.null(levels)) {
        plots[[3]] <- list(
            weight=0.25,
            type='bar',
            data=levels[dend.row$order],
            title='row\nmean'
        )
    }
    
    multiplot(
        plots,
        lapply(labels, function(item) item[dend.row$order])
    )

    list(
        dend.row = dend.row,
        dend.col = dend.col
    )   
    
    #if (n.rows < 2 || n.cols < 2) {
    #    plot.new()
    #    title(sprintf('Can\'t plot %d x %d heatmap', n.rows, n.cols))
    #} else {
    #    dend.row.x1 <- 1/90
    #    dend.row.x2 <- 1/9
    #    
    #    dend.col.y1 <- 1.0 - dend.row.x2 * aspect.ratio()
    #    dend.col.y2 <- 1.0 - (1.0-dend.col.y1)*0.1
    #    
    #    y1 <- 4 / par()$fin[2]
    #    y2 <- dend.col.y1
    #    
    #    x1 <- dend.row.x2
    #    x2 <- 1/3
    #
    #    legend.y2 <- y1*0.75
    #    legend.y1 <- legend.y2 - 0.03*aspect.ratio()
    #    legend.x1 <- 15/30
    #    legend.x2 <- 18/30
    #
    #    if (signed) {
    #        col <- signed.col
    #        extreme <- max(0.0,abs(mat),na.rm=TRUE)
    #        breaks <- seq(-extreme,extreme, length=length(col)+1)
    #    } else {
    #        col <- unsigned.col
    #        extreme <- max(0,mat,na.rm=TRUE)
    #        breaks <- seq(0,extreme, length=length(col)+1)
    #    }
    #            
    #    plot.new()
    #    
    #    if (!is.null(dend.col$dendrogram)) {
    #        put.plot(x1,x2, dend.col.y1,dend.col.y2)
    #        plot(dend.col$dendrogram, horiz=FALSE, axes=FALSE, yaxs="i", leaflab="none")
    #    }
    #    
    #    if (!is.null(dend.row$dendrogram)) {
    #        put.plot(dend.row.x1,dend.row.x2, y1,y2)
    #        plot(dend.row$dendrogram, horiz=TRUE, axes=FALSE, yaxs="i", leaflab="none")
    #    }
    #    
    #    put.plot(x1,x2, y1,y2)
    #    basic.image(1:n.cols,1:n.rows, t(mat[dend.row$order,dend.col$order,drop=FALSE]), col=col, breaks=breaks)
    #    axis(1, at=1:n.cols, labels=colnames(mat), las=2, tick=FALSE)
    #
    #    line <- 0
    #    for(i in basic.seq(length(labels))) {
    #        if (i < length(labels))
    #            l <- trim.labels(labels[[i]])
    #        else
    #            l <- as.character(labels[[i]])
    #        axis(4, at=1:n.rows, labels=l[dend.row$order], las=2, tick=FALSE, line=line)
    #        line <- line + 0.45 * max(0,nchar(l))
    #    }
    #    
    #    put.plot(legend.x1,legend.x2, legend.y1,legend.y2)
    #    color.legend(col, breaks, legend)        
    #}
    #
    #list(
    #    dend.row = dend.row,
    #    dend.col = dend.col
    #)   
}

#nesoni.heatmap <- function(x, reorder.columns=FALSE,dist.row=NA,dist.col=NA, ...) {    
    #if(!is.matrix(x)) x <- as.matrix(x)
    #
    #if (all(is.na(dist.row))) 
    #    dist.row <- dist( t(scale(t(x))) )
    #
    #if (all(is.na(dist.col)) && reorder.columns) 
    #    dist.col <- dist( scale(t(x)) )
    #
    #method <- 'OLO'
    #
    #if (reorder.columns) {   
    #    control <- list(hclust = hclust(dist.col))
    #    dend.col <- as.dendrogram(
    #            seriation::seriate(dist.col, 
    #            method = method, control = control)[[1]])
    #    dend <- 'both'
    #} else {    
    #    dend.col <- NA
    #    dend <- 'row'
    #}
    #
    #control <- list(hclust = hclust(dist.row))
    #dend.row <- as.dendrogram(
    #        seriation::seriate(dist.row, 
    #        method = method, control = control)[[1]])
    #
    #result <- gplots::heatmap.2(x, Colv = dend.col, Rowv = dend.row, dendrogram = dend, 
    #                  scale = "none", trace='none', density.info='none', 
    #                  lwid=c(2,par("din")[1]-2), lhei=c(1.5,par("din")[2]-1.5),
    #                  cexCol=1.0,
    #                  ...)
    #
    #invisible(result)
#}    

unsigned.col <- hsv(h=seq(0.95,1.15, length.out=256)%%1.0, v=seq(0,1, length.out=256)**0.5,s=seq(1,0,length.out=256)**0.5)
signed.col <- hsv(h=(sign(seq(-1.0,1.0, length.out=256))*0.2+0.8)%%1.0, v=1,s=abs(seq(-1,1,length.out=256)))


svd.gene.picker <- function(mat, svd.rank=NULL, min.svd=2.0) {
    if (is.null(svd.rank))
        svd.rank <- ncol(mat)-1
    s <- svd(t(scale(t(mat), center=TRUE,scale=FALSE)), nu=svd.rank,nv=svd.rank)
    cat('SVD d diagonal:\n')
    print(s$d[basic.seq(svd.rank)])
    mag <- sqrt( rowSums(s$u*s$u) * nrow(s$u) / ncol(s$u) )
    mag >= min.svd
}


hmap.elist <- function(filename.prefix, elist, 
                       min.sd=0.0, min.span=0.0, min.svd=0.0, svd.rank=NULL,
                       annotation=c('gene', 'product'), 
                       res=150, row.labels=NA,
                       reorder.columns = FALSE) {
    keep <- rep(TRUE, nrow(elist$E))

    if (min.sd > 0.0) {
        sd <- sqrt(row.apply(elist$E, var))
        keep <- (keep & sd >= min.sd)
    }
    
    if (min.span > 0.0) {    
        span <- row.apply(elist$E, max) - row.apply(elist$E, min)
        keep <- (keep & span >= min.span)
    }
    
    if (min.svd > 0.0) {
        #if (is.null(svd.rank))
        #    svd.rank <- ncol(elist$E)-1
        #s <- svd(t(scale(t(elist$E), center=TRUE,scale=FALSE)), nu=svd.rank,nv=svd.rank)
        #cat('SVD d diagonal:\n')
        #print(s$d[basic.seq(svd.rank)])
        #mag <- sqrt( rowSums(s$u*s$u) * nrow(s$u) / ncol(s$u) )
        #keep <- (keep & mag >= min.svd)
        
        keep <- keep & svd.gene.picker(elist$E, svd.rank, min.svd)
    }
    
    elist <- elist[keep,]
    
    averages <- rowMeans(elist$E)
    
    if (is.na(row.labels))
        row.labels <- (nrow(elist) <= 300)

    data <- t(scale(t(elist$E), center=TRUE,scale=FALSE))

    labels <- list(rownames(data))
    
    for(colname in annotation)
        if (!all(is.na(elist$gene[,colname])))
            labels[[ length(labels)+1 ]] <- elist$gene[,colname]
        
    height <- if(row.labels) (25*nrow(data)+800)*res/150 else 2500*res/150    
    png(sprintf('%s.png',filename.prefix), width=2000*res/150, height=height, res=res)
    
    #heatmap <- nesoni.heatmap(data, col=signed.col, symkey=TRUE,symbreaks=TRUE, labRow=(if(row.labels) NULL else NA), margins=margins, main=main, ...)
    heatmap <- nesoni.heatmap(data, labels=if(row.labels) labels else list(), reorder.columns=reorder.columns, levels=averages)

    dev.off()

    shuffled.elist <- elist[rev(heatmap$dend.row$order),]
    
    table.filename <- sprintf('%s.csv', filename.prefix)
    
    sink(table.filename)
    cat('# Heatmap data\n')
    cat('#\n')
    cat('# Values given are log2 reads per million\n')
    cat('#\n')
    cat(sprintf('# %d genes shown\n', nrow(data)))
    cat('#\n')

    frame <- data.frame(name=rownames(shuffled.elist$E), row.names=rownames(shuffled.elist$E), check.names=FALSE) 
    for(colname in annotation) {
        frame[,colname] <- shuffled.elist$gene[,colname]
    }     
    #frame[,'cluster hierarchy'] <- rev(dendrogram.paths(heatmap$rowDendrogram))
    frame[,'cluster hierarchy'] <- rev(heatmap$dend.row$paths)
    frame <- data.frame(frame, shuffled.elist$E, check.names=FALSE)
    
    write.csv(frame, row.names=FALSE)
    sink()

    invisible(list(heatmap=heatmap, frame=frame))
}

# Functions for dealing with table created by "nesoni count:"

read.counts <- function(filename, min.total=0, min.max=0, keep=NULL, norm.file=NULL, use.tmm=TRUE) {    
    #data <- read.delim(filename, check.names=FALSE)
    #rownames(data) <- data$Feature
    #n_samples <- grep('^RPKM', colnames(data))[1] - 2
    #counts <- as.matrix( data[,2:(n_samples+1), drop=FALSE] )
    #gene <-data[, (n_samples*2+2):ncol(data)]
    
    data <- read.grouped.table(filename, require=c('Count','Annotation'))
    counts <- as.matrix( data$Count )
    gene <- data$Annotation
    n_samples <- ncol(counts)
    
    
    cat(sprintf("%d genes\n", nrow(counts)))
    
    have.norm <- !is.null(norm.file)
    if (have.norm) {
        #norm <- read.delim(norm.file, check.names=FALSE)
        #rownames(norm) <- norm$Sample
        norm <- read.grouped.table(norm.file, require=c('All'))$All
        
        # Make counts have same order as norm file, throw out columns not included
        counts <- counts[,rownames(norm),drop=FALSE]
        n_samples <- ncol(counts)
    }
    
    if (!is.null(keep)) {
        counts <- counts[,keep,drop=FALSE]
        if (have.norm)
            norm <- norm[keep,,drop=FALSE]
        n_samples <- ncol(counts)
    }
    
    totals <- mapply(function(i) sum(counts[i,]), 1:nrow(counts))
    maximums <- mapply(function(i) max(counts[i,]), 1:nrow(counts))    
    good <- totals >= min.total & maximums >= min.max

    cat(sprintf("%d genes after filtering\n", sum(good)))
    
    result <- DGEList(counts=counts[good,], gene=gene[good,])

    mean.lib.size <- exp(mean(log(result$samples$lib.size)))

    if (!have.norm) {
        if (use.tmm) {
            result <- calcNormFactors(result)
        } else {
            result$samples$norm.factors <- rep(1, n_samples)
        }
        
        effective.sizes <- result$samples$lib.size * result$samples$norm.factors
        result$samples$normalizing.multiplier <- mean.lib.size / effective.sizes 
    } else {
        result$samples$normalizing.multiplier <- norm$Normalizing.multiplier
        effective.sizes <- mean.lib.size / result$samples$normalizing.multiplier
        result$samples$norm.factors <- effective.sizes / result$samples$lib.size
    }
    
    result$original.number.of.genes <- nrow(counts)    

    cat('                        Sample    Library size   Further         Normalizing\n')
    cat('                                                 norm factor     multiplier\n')
    for(i in 1:n_samples) {
        cat(sprintf("%30s %15d %10.2f %15.2f\n", colnames(result$counts)[i], result$samples$lib.size[i], result$samples$norm.factors[i], result$samples$normalizing.multiplier[i]))
    }
    cat('\n\n')
    
    result
}

# Normalize to reads per million (+/- a few TMM tweaks)
reads.per.million <- function(dgelist) {
    effective.sizes <- dgelist$samples$lib.size * dgelist$samples$norm.factors
    t( t(dgelist$counts)/effective.sizes * 1e+06 )
}

# Normalize roughly preserving the overall count magnitude
normalized.counts <- function(dgelist) {
    t( t(dgelist$counts) * dgelist$samples$normalizing.multiplier )
}

# Similar to a log transformation, however glog2(0, m) = log2(m) rather than negative infinity.
#
# Stabilizes variance of values with a constant noise component plus a componet that scales with the data
#
glog2 <- function(x,m=1) log2((x+sqrt(x*x+4*m*m))/2)

# glog2 transformation, resulting in moderated log2 Reads Per Million values
# 
# B.P. Durbin, J.S. Hardin, D.M. Hawkins and D.M. Rocke (2002)
# A variance-stabilizing transformation for gene-expression microarray data.
# Bioinformatics (2002) 18 (suppl 1): S105-S110. 
#
glog2.rpm.counts <- function(dgelist, moderation=5.0) {
    lib.size <- dgelist$samples$lib.size * dgelist$samples$norm.factors
    mean.size <- mean(lib.size)

    #e <- glog2( t(t(dgelist$counts)*(1e6/lib.size)), moderation*1e6/mean.size )
    #e <- log2( t(t(dgelist$counts)*(1e6/lib.size)) + moderation*1e6/mean.size ) 
    e <- matrix(nrow=nrow(dgelist$counts),ncol=ncol(dgelist$counts))
    rownames(e) <- rownames(dgelist$counts)
    colnames(e) <- colnames(dgelist$counts)
    for(i in basic.seq(ncol(e))) {
        e[,i] <- glog2( dgelist$counts[,i] * (1e6/lib.size[i]), moderation*(1e6/mean.size))
        #e[,i] <- glog2(dgelist$counts[,i]*1.0, moderation) + log2(1e6/lib.size[i])
    }
    
    out <- list()
    out$E <- e
    out$lib.size <- lib.size
    out$genes <- dgelist$genes
    out$targets <- dgelist$samples
    new("EList", out)
}





row.apply <- function(data, func) {
    mapply(function(i) func(data[i,]), 1:nrow(data))
}
